ignoredHolidays = {};

local frame = CreateFrame("FRAME", "");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("CALENDAR_UPDATE_EVENT_LIST");
frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("VARIABLES_LOADED");

if (not IsAddOnLoaded("Blizzard_Calendar")) then
		UIParentLoadAddOn("Blizzard_Calendar");
end

local function eventHandler(self, event, ...)
	if (event == "VARIABLES_LOADED") then
		ignoredHolidays = ignoredHolidays;
	end
	if (event == "PLAYER_ENTERING_WORLD") then
		frame:UnregisterEvent("PLAYER_ENTERING_WORLD");
		OpenCalendar();
	end
	if (event == "CALENDAR_UPDATE_EVENT_LIST") then
		frame:UnregisterEvent("CALENDAR_UPDATE_EVENT_LIST");
		holidayReminder();
	end
end

frame:SetScript("OnEvent", eventHandler);

SLASH_HOLIDAYREMINDER1 = "/hr";
function SlashCmdList.HOLIDAYREMINDER(msg)
	if (msg == "ignored") then
		printIgnored();
	elseif (msg ~= "") then
		if (ignoredHolidays[msg] == true) then
			print("Removing "..msg.." from the ignore list");
			msg = string.lower(msg);
			ignoredHolidays[msg] = false;
		else
			print("Adding "..msg.." to the ignore list");
			msg = string.lower(msg);
			ignoredHolidays[msg] = true;
		end	
	else
		holidayReminder();
	end
end

function holidayReminder()
	weekday, month, day, year = CalendarGetDate();
	serverHour, serverMinute = GetGameTime();
		
	for i=1,CalendarGetNumDayEvents(0, day) do
		local title, holidayHour, holidayMinute, calendarType, sequenceType, eventType, texture, modStatus, inviteStatus, invitedBy, difficulty, inviteType = CalendarGetDayEvent(0, day, i);
		local numDays = 1;
		
		if (not isIgnored(title)) then
			if (sequenceType == "START") then
				if (serverHour > holidayHour) then
					texture = "Interface\\Calendar\\Holidays\\"..texture.."Start";
					numDays = getDaysLeft(title, day+1);
					createHolidayFrame(title, texture, numDays);
				end
			elseif (sequenceType == "END") then
				if (serverHour < holidayHour) then
					texture = "Interface\\Calendar\\Holidays\\"..texture.."End";
					numDays = getDaysLeft(title, day+1);
					createHolidayFrame(title, texture, numDays);
				end
			elseif (sequenceType == "ONGOING") then
				texture = "Interface\\Calendar\\Holidays\\"..texture.."Start";
				numDays = getDaysLeft(title, day+1);
				createHolidayFrame(title, texture, numDays);
			end
		end
	end
end

function createHolidayFrame(title, texture, numDays)
	local Toast = LibStub("LibToast-1.0")
	
	Toast:Register("HolidayReminder", function(toast, title, texture, numDays)
		toast:SetTitle("Holiday Reminder");

		if (numDays > 1) then
			toast:SetText(title..":|n     "..numDays.." days left");
		else
			toast:SetText(title..":|n     "..numDays.." day left")
		end
		toast:SetIconTexture(texture);
		toast:MakePersistent();
	end)
	
	Toast:Spawn("HolidayReminder", title, texture, numDays)
end

function getDaysLeft(title, tomorrow)
	local numDays = 1;
	local month = 0;
	local counter = 1;
	
	repeat
		for i=1,CalendarGetNumDayEvents(month, tomorrow) do
			titleTomorrow = CalendarGetDayEvent(month, tomorrow, i);
			
			if (titleTomorrow == title) then
				numDays = numDays + 1;
				tomorrow = tomorrow + 1;
				break;
			end
		end
		
		if (tomorrow > 31) then
			month = 1;
			tomorrow = 1;
		end
		
		counter = counter + 1;
	until(counter > 35)
	
	return numDays;
end

function isIgnored(title)
	title = string.lower(title);
	
	if (ignoredHolidays[title]) then
		return true;
	end
	
	return false;
end

function printIgnored()
	for k,v in pairs(ignoredHolidays) do 
		if (ignoredHolidays[k]) then
			print(k.." is ignored"); 
		end
	end
end